//
// Copyright 2013, Authenticade LLC
// MIT License - See LICENSE file for details.
//

// These placeholders will contain the actual ticket handlers.
var CK_HEAD = document.getElementsByTagName('head')[0];
var CK_HANDLER = document.createElement('script');
var CK_URL = document.URL;
var CK_ATTEMPTS = 3;

// Insert the initially empty script block.
CK_HEAD.appendChild(CK_HANDLER);

// Get an HTTP connection object.
function ck_get_connector()
{
  try { return new XMLHttpRequest(); } catch (error) { }
  try { return new ActiveXObject("Msxml2.XMLHTTP"); } catch (error) { }
  try { return new ActiveXObject("Microsoft.XMLHTTP"); } catch (error) { }
  throw new Error("Could not create HTTP request object.");
}

// Acquire a ticket from CryoKey's ticketing module.
function ck_ticket(_url, _ip, _pass)
{
  var ticketer = "https://www.cryokey.com/private/ticket.php?url=" + escape(_url) + "&ip=" + escape(_ip);

  CK_ATTEMPTS--;
  CK_URL = _pass;
  CK_HEAD.removeChild(CK_HANDLER);

  CK_HANDLER = document.createElement('script');
  CK_HANDLER.type = "text/javascript";
  CK_HANDLER.onabort = function()
  {
    window.location = _url;
  }
  CK_HANDLER.onerror = function()
  {
    if (CK_ATTEMPTS > 0)
      ck_ticket(_url, _ip, _pass);
    else
      window.location = _url;
  }
  CK_HANDLER.src = ticketer;

  CK_HEAD.appendChild(CK_HANDLER);
}

// Complete authentication by passing the TicketID to the target
// service.
function ck_login(_tid)
{
  if (/\?/.test(CK_URL))
    window.location = CK_URL + "&ckid=" + escape(_tid);
  else
    window.location = CK_URL + "?ckid=" + escape(_tid);
}
